import java.util.*;
import java.rmi.*;
import java.net.*;
import java.rmi.server.*;

public class BrokerImpl extends UnicastRemoteObject implements Broker
{	InetAddress indirizzoNameServer;

	public BrokerImpl(InetAddress indirizzoNameServer) throws RemoteException
	{	super();
		this.indirizzoNameServer=indirizzoNameServer;
	}

	public Vector elencoServizi(String nomeComputingServer)
	{	ComputingServer cs=trova(nomeComputingServer);
		Vector ret=new Vector();
		try
		{	ret=cs.serviziOfferti();
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}

	public Object invoca(String nomeComputingServer, String nomeServizio, Object parametro)
	{	ComputingServer cs=trova(nomeComputingServer);
		Object ret=null;
		try
		{	ret=cs.invocaServizio(nomeServizio,parametro);
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}

	public Object invocaGenerico(String parolaChiave, Object parametro)
	{	Object ret=null;
		try
		{	NameServer ns = (NameServer)Naming.lookup("rmi://"+indirizzoNameServer.getHostAddress()+":1099/NameServer");
			Vector ipCSs=ns.elencoComputingServer();
			boolean trovato=false;
			for(int i=0;i<ipCSs.size() && !trovato;i++)
			{	ComputingServer cs=(ComputingServer)Naming.lookup("rmi://"+(InetAddress)ipCSs.get(i)+":1099/ComputingServer");
				Vector servizi=cs.serviziOfferti();
				for(int j=0;j<servizi.size() && !trovato;j++)
				{	Servizio s=(Servizio)servizi.get(j);
					if(s.getDescrizione().contains(parolaChiave))
					{	trovato=true;
						ret=cs.invocaServizio(s.getNome(),parametro);
					}
				}
			}
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}

	private ComputingServer trova(String nomeComputingServer)
	{	ComputingServer ret=null;
		try
		{	NameServer ns = (NameServer)Naming.lookup("rmi://"+indirizzoNameServer.getHostAddress()+":1099/NameServer");
			InetAddress ipCS=ns.risolvi(nomeComputingServer);
			ret=(ComputingServer)Naming.lookup("rmi://"+ipCS.getHostAddress()+":1099/ComputingServer");
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}
}