import java.rmi.*;
import java.util.*;
import java.net.*;
import java.rmi.server.*;

public class NameServerImpl extends UnicastRemoteObject implements NameServer
{	private String dominio; //la radice ha dominio ""
	private InetAddress padre;
	private HashMap figli; //associazione sottodominio->InetAddress del figlio
	private boolean eFoglia;

	public NameServerImpl(String dominio,InetAddress padre, boolean eFoglia) throws RemoteException
	{	super();
		this.dominio=dominio;
		this.padre=padre;
		this.eFoglia=eFoglia;
	}

	public void aggiungiFiglio(String sottoDominio, InetAddress indirizzo)
	{	figli.put(sottoDominio,indirizzo);
	}

	public InetAddress risolvi(String nomeComputingServer)
	{	InetAddress ret=null;
		if(eFoglia)
		{	if (nomeComputingServer.startsWith(dominio))
			{	String sottoDominio=nomeComputingServer.substring(dominio.length());
				String nomeFoglia=sottoDominio.substring(0,nomeComputingServer.indexOf("."));
				if(figli.containsKey(nomeFoglia))
					ret=(InetAddress)figli.get(nomeFoglia);
			}
			else
				return risolviSuAltroNodo(padre,nomeComputingServer);
		}
		else
		{	if (nomeComputingServer.startsWith(dominio))
			{	String sottoDominio=nomeComputingServer.substring(dominio.length());
				String nomeFiglio=sottoDominio.substring(0,nomeComputingServer.indexOf("."));
				if(figli.containsKey(nomeFiglio))
					return risolviSuAltroNodo((InetAddress)figli.get(nomeFiglio),nomeComputingServer);
			}
			else
				return risolviSuAltroNodo(padre,nomeComputingServer);
		}
		return ret;
	}

	private InetAddress risolviSuAltroNodo(InetAddress indirizzoNodo, String nomeComputingServer)
	{	if(indirizzoNodo==null)
			return null;

		InetAddress ret=null;
		try
		{	NameServer ns = (NameServer)Naming.lookup("rmi://"+indirizzoNodo.getHostAddress()+":1099/NameServer");
			ret=ns.risolvi(nomeComputingServer);
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}

	public Vector elencoComputingServer()
	{	Vector ret=new Vector();
		InetAddress radice=risolvi("");
		try
		{	NameServer ns = (NameServer)Naming.lookup("rmi://"+radice+":1099/NameServer");
			ret=ns.elencoCSLivelliInferiori();
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		return ret;
	}

	public Vector elencoCSLivelliInferiori()
	{	if(eFoglia)
			return new Vector(figli.values());

		Vector ret=new Vector();
		for(Iterator it=figli.values().iterator();it.hasNext();)
		{	InetAddress figlio=(InetAddress)it.next();
			try
			{	NameServer ns = (NameServer)Naming.lookup("rmi://"+figlio+":1099/NameServer");
				ret.add(ns.elencoCSLivelliInferiori());
			}
			catch (Exception e)
			{	System.out.println(e);
			}
		}
		return ret;
	}
}